<?php

namespace Util;

use Zeedhi\Framework\DependencyInjection\InstanceManager;

class InstanceProvider {

    /** @return \Teknisa\Libs\Service\Api */
    public static function getLibServiceApi()
    {
        return InstanceManager::getInstance()->getService('apiService');
    }

    /** @return \Teknisa\Libs\Service\Login */
    public static function getLibServiceLogin()
    {
        return InstanceManager::getInstance()->getService('loginService');
    }

    /** @return \Teknisa\Libs\Util\Utilities */
    public static function getLibUtilities()
    {
        return InstanceManager::getInstance()->getService('libUtilities');
    }

    /** @return \Teknisa\Libs\Util\OAuthCustom */
    public static function getOAuth()
    {
        return InstanceManager::getInstance()->getService('oAuthImpl');
    }

    /** @return \Teknisa\Libs\Util\Environment */
    public static function getLibEnvironment()
    {
        return InstanceManager::getInstance()->getService('libEnvironment');
    }

    /** @return \Teknisa\Libs\Util\Login\UserDataProvider */
    public static function getLibUserDataProvider()
    {
        return InstanceManager::getInstance()->getService('libUserDataProvider');
    }

    /** @return \Teknisa\Libs\Util\Repositories\UserData */
    public static function getLibUserDataRepository()
    {
        return InstanceManager::getInstance()->getService('libUserDataRepository');
    }

    /** @return \Teknisa\Libs\Util\ConnectionCustom */
    public static function getLibConnectionCustom()
    {
        return InstanceManager::getInstance()->getService('connectionCustom');
    }

    /** @return \Teknisa\Libs\Util\NewCode */
    public static function getLibNewCode()
    {
        return InstanceManager::getInstance()->getService('newCodeSC');
    }

    /** @return \Teknisa\Libs\Service\Menu */
    public static function getLibMenuService()
    {
        return InstanceManager::getInstance()->getService('libMenuService');
    }

    /** @return \Zeedhi\Framework\Session\Session */
    public static function getSession()
    {
        return InstanceManager::getInstance()->getService('session');
    }

    /** @return \Teknisa\Libs\Util\SMTP */
    public static function getSmtpMail()
    {
        return InstanceManager::getInstance()->getService('smtpUtil');
    }

    /** @return \Doctrine\ORM\EntityManager */
    public static function getEntityManager()
    {
        return InstanceManager::getInstance()->getService('entityManager');
    }

    /** @return \Services\FileServer */
    public static function getFileServerService()
    {
        return InstanceManager::getInstance()->getService('Services\FileServer');
    }
    
}