/* Sistemas Integrados TECNISA
   Compras e Suprimentos

Nome: USR_EXPIRA_AF.sql

Descrio:
As AF's em aberto cuja data de entrega de um ou mais produtos superior
ao nmero de dias estipulado pelo parmetro, a mesma ser "expirada".


Criao:
13/07/2007 Pedro Nerino Viol de Lima.
*/


CREATE OR REPLACE PROCEDURE USR_EXPIRA_AF
IS
   V_IDUTILDTPROC    VARCHAR2(1);
   V_NRMAXDIASIMPAF  FLOAT;
   V_CONT_COMMIT NUMBER := 0;
   V_QTDE_COMMIT NUMBER := 500;
   
BEGIN

   SELECT
     NVL(MAX(IDUTILDTPROC), 'N'),
     NVL(MAX(NRMAXDIASIMPAF), 0)
   INTO
      V_IDUTILDTPROC,
      V_NRMAXDIASIMPAF
   FROM
     PARAMGERAL;

   V_CONT_COMMIT := 0;
   
   IF (V_NRMAXDIASIMPAF > 0) THEN
      FOR C_AUTOFORNE IN
         (SELECT
            A.CDFILDEST,
            A.CDFILLANC,
            A.NRAUTOFORN
          FROM
             AUTOFORNE A,
             PARAMFILIAL P
          WHERE
             (A.CDFILDEST  = P.CDFILIAL)   AND
             ((NVL(A.IDBAIXAAF, '1') = '1') OR (A.IDBAIXAAF = '7'))  AND
             (NVL(A.IDAFEXPIRADA, 'N') = 'N')        AND
             (A.CDFILDEST NOT IN('8746','8736','3363')) AND
             EXISTS
                 (SELECT
                    '1'
                  FROM
                     ITEMAUTF I
                  WHERE
                     A.CDFILDEST  = I.CDFILDEST  AND
                     A.CDFILLANC  = I.CDFILLANC  AND
                     A.NRAUTOFORN = I.NRAUTOFORN AND
                    (DECODE(V_IDUTILDTPROC, 'S', NVL(P.DTPROCESSA, TRUNC(SYSDATE)), TRUNC(SYSDATE)) - I.DTPROGENTAF) > V_NRMAXDIASIMPAF)
          GROUP BY
             A.CDFILDEST,
             A.CDFILLANC,
             A.NRAUTOFORN
         ) LOOP

             V_CONT_COMMIT := V_CONT_COMMIT + 1;
             UPDATE
                AUTOFORNE
             SET
                IDAFEXPIRADA = 'S'
             WHERE
                CDFILDEST  = C_AUTOFORNE.CDFILDEST AND
                CDFILLANC  = C_AUTOFORNE.CDFILLANC AND
                NRAUTOFORN = C_AUTOFORNE.NRAUTOFORN;

             IF (V_CONT_COMMIT >= V_QTDE_COMMIT) THEN
                V_CONT_COMMIT := 0;
                COMMIT;
             END IF;
      END LOOP;
   END IF;
   COMMIT;
END;
/



-- VERSAO --
BEGIN ATUVEROBJ('USR_EXPIRA_AF','4.11.159'); END;
/

